package gpl.fredy.webmail;

import java.util.Properties;
import java.util.StringTokenizer;
import java.util.Vector;
import javax.mail.*;
import javax.mail.internet.*;
import java.io.*;
import com.sun.mail.pop3.*;

public class GetMessages {

    String host;
    public void   setHost(String v) { this.host=v; }
    public String getHost()  { return this.host; }
    
    String user;
    public void   setUser(String v) { this.user = v; }
    public String getUser() { return this.user; }
    
    String password;
    public void   setPassword(String v) { this.password = v; }
    public String getPassword() { return this.password; }
    
    public Vector yourMessages;
    public Vector getYourMessages() { return yourMessages; }

    private Message message[];
    private Store store;
    public Store getStore() { return store; }

    private Session session;
    public Session getSession() { return session; }
 

    public Folder folder;  

    boolean success=true;
    
    /**
     * Get the value of success.
     * @return value of success.
     */
    public boolean isSuccess() {
	return success;
    }
    
    /**
     * Set the value of success.
     * @param v  Value to assign to success.
     */
    public void setSuccess(boolean  v) {
	this.success = v;
    }
    


    public static void main (String args[]) throws Exception {
	
	System.out.println("Fredy's MailHeader Fetcher\n\n" +
			   "Option {-3|-4} -s [mailstore] -h [SMTPHost] -u [username] -p [password]\n" +
			   "-3 = pop3\n-4 = imap");
	
        String host      = "localhost";
	String store     = "localhost";
        String proto     = "pop3";
        String user      = " ";
        String password  = " ";
	int i = 0;
	
	while ( i < args.length) {
	    
	    if ((args[i].equals("-h") ) || (args[i].equals("-host")) ) {		
		i++;
		host=args[i];
	    }    
	    if ((args[i].equals("-s") ) || (args[i].equals("-store")) ) {		
		i++;
		store=args[i];
	    }    
	    if ((args[i].equals("-3") ) || (args[i].equals("-pop3")) ) {		
		proto="pop3";
	    }    
	    if ((args[i].equals("-4") ) || (args[i].equals("-imap")) ) {		
		proto="imap";
	    }    
	    if ((args[i].equals("-u") ) || (args[i].equals("-user")) ) {
		i++;
		user=args[i];	
	    }    
	    if ((args[i].equals("-p") ) || (args[i].equals("-password")) ) {	
	      	i++;
		password=args[i];	
	    }    
            i++;
	}
        GetMessages gh = new GetMessages(store,host,proto,user, password);
        for ( i = 0; i < gh.yourMessages.size();i++) {
	    MessageHeader mh = new MessageHeader();
            mh = (MessageHeader)gh.yourMessages.elementAt(i);
            System.out.println(mh.getSubject());
	}
	gh.getStore().close();
       
    }

    public GetMessages(Session session, Folder folder, int start, int end) {
	yourMessages = new Vector();
	try {
	    message = folder.getMessages(start,end);
	} catch (MessagingException mxe) {
	  System.out.println("Messaging Exception for user " + user + "\n" );
	  mxe.printStackTrace();
	  setSuccess(false);
	}    
	fillMessages();


    }
    public GetMessages(String storeHost, String sendHost,String proto, String user, String password) {

     
     yourMessages = new Vector();
     

    // Create empty properties
	Properties props = System.getProperties();
        props.put("mail.smtp.host", sendHost);


    // Get session
	session = Session.getDefaultInstance(props, null);

    // Get the store
	try {
	  //store = session.getStore("pop3");
	  //store = session.getStore("imap");

	  store = session.getStore(proto);
	} catch (NoSuchProviderException nspe) { 
	  System.out.println("no such Provider exception for user " + user + "\n") ;
	  nspe.printStackTrace();
          setSuccess(false);
	}
			     
	try {
	  // Connect to store
	  store.connect(storeHost, user, password);
	  
	  // Get folder
	  folder = store.getFolder("INBOX");        
	
	  // Open read-only
	  //folder.open(Folder.READ_ONLY);

	  // Open read-write
	  folder.open(Folder.READ_WRITE);
       
	  // Get directory
	  message = folder.getMessages();
   
	} catch (MessagingException mxe) {
	  System.out.println("Messaging Exception for user " + user + "\n" );
	  mxe.printStackTrace();
	  setSuccess(false);
	}
	fillMessages();
	/**
	   try {
	   store.close();
	   } catch (MessagingException mxec) {
	   System.out.println("(closeing) Messaging exception for user " + user + "\n" );
	   mxec.printStackTrace();
	  }
	**/
  }

    private void fillMessages() {

	for ( int j=0; j < message.length; j++) {
	 MimeMessage mm = (MimeMessage)message[j];
	 Part        p  = mm;
	 yourMessages.addElement((MessageHeader) new MessageHeader(message[j]));
	}

    }
}
     
