package gpl.fredy.webmail;

/**

    Copyright (c) 1999 Fredy Fischer
                       se-afs@dial.eunet.ch

		       Fredy Fischer
		       Hulmenweg 36
		       8405 Winterthur
		       Switzerland

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA


**/

import java.util.Calendar;
import java.util.Date;
import java.text.SimpleDateFormat;
import javax.mail.*;
import javax.mail.internet.*;
import gpl.fredy.webmail.*;
import java.util.logging.*;

public class MailList {

    private Logger logger;

    String borderColor= "lightblue";
    
    /**
     * Get the value of borderColor.
     * @return value of borderColor.
     */
    public String getBorderColor() {
	return borderColor;
    }
    
    /**
     * Set the value of borderColor.
     * @param v  Value to assign to borderColor.
     */
    public void setBorderColor(String  v) {
	this.borderColor = v;
    }
    

    String rowColor1 = "white";
    
    /**
     * Get the value of rowColor1.
     * @return value of rowColor1.
     */
    public String getRowColor1() {
	return rowColor1;
    }
    
    /**
     * Set the value of rowColor1.
     * @param v  Value to assign to rowColor1.
     */
    public void setRowColor1(String  v) {
	this.rowColor1 = v;
    }
    

    String rowColor2 = "lightblue";
    
    /**
     * Get the value of rowColor2.
     * @return value of rowColor2.
     */
    public String getRowColor2() {
	return rowColor2;
    }
    
    /**
     * Set the value of rowColor2.
     * @param v  Value to assign to rowColor2.
     */
    public void setRowColor2(String  v) {
	this.rowColor2 = v;
    }
    

    StringBuffer mails;
    
    /**
     * Get the value of mails.
     * @return value of mails.
     */
    public String getMails() {
	return mails.toString();
    }
    
    /**
     * Set the value of mails.
     * @param v  Value to assign to mails.
     */
    public void setMails(StringBuffer  v) {
	this.mails = v;
    }
    

    Session session;
    
    /**
     * Get the value of session.
     * @return value of session.
     */
    public Session getSession() {
	return session;
    }
    
    /**
     * Set the value of session.
     * @param v  Value to assign to session.
     */
    public void setSession(Session  v) {
	this.session = v;
    }
    
    Folder folder;
    
    /**
     * Get the value of folder.
     * @return value of folder.
     */
    public Folder getFolder() {
	return folder;
    }
    
    /**
     * Set the value of folder.
     * @param v  Value to assign to folder.
     */
    public void setFolder(Folder  v) {
	this.folder = v;
    }
    
    int start;
    
    /**
     * Get the value of start.
     * @return value of start.
     */
    public int getStart() {
	return start;
    }
    
    /**
     * Set the value of start.
     * @param v  Value to assign to start.
     */
    public void setStart(int  v) {
	this.start = v;
    }
    
    int end;
    
    /**
     * Get the value of end.
     * @return value of end.
     */
    public int getEnd() {
	return end;
    }
    
    /**
     * Set the value of end.
     * @param v  Value to assign to end.
     */
    public void setEnd(int  v) {
	this.end = v;
    }
    



    public MailList(Session session,
		    Folder  folder,
                    int start, int end,
                    String borderColor,
		    String rowColor1,
                    String rowColor2) 
    {
         
	setBorderColor(borderColor);
	setRowColor1(rowColor1);
        setRowColor2(rowColor2);
        setSession(session);
	setFolder(folder);
	setStart(start);
	setEnd(end);
	   

        doIt();

    }

    public MailList(Session session,
		    Folder  folder,
                    int start, int end) {
	setSession(session);
	setFolder(folder);
	setStart(start);
	setEnd(end);
	   
	doIt();
    }

    private void doIt() {

	GetMessages gh = new GetMessages((javax.mail.Session)getSession(),
					 (javax.mail.Folder)getFolder(),
                                         (int) getStart(),
					 (int) getEnd());
	
	mails = new StringBuffer("");
        String bgColor = getRowColor2();
	if ( gh.isSuccess() ) {

	 
            int display = gh.yourMessages.size();
            System.out.println("number of messages in MailList is: " + display);
            for (int i = 0;i < display; i++ ) {

	       MessageHeader mh = new MessageHeader();
               mh = (MessageHeader) gh.yourMessages.elementAt(i);
               String from = "";
               String to   = "";
               String sub  = "";
               try {
   	         from = (String)mh.getFrom().elementAt(0);
               } catch (Exception e1) { from ="unknown"; }
 
               try {
  	         to   = (String)mh.getRecipients().elementAt(0);
               } catch (Exception e2) { to = "unknown"; }

               try {
                  sub  = mh.getSubject();
               } catch (Exception e3) { sub = " "; }
               if ( sub.length() > 45 )  sub = sub.substring(0,42) + "...";

               // Date
               java.util.Calendar cal = java.util.Calendar.getInstance();
               cal.setTime(mh.getRcvDate());

	       SimpleDateFormat formatter
		   = new SimpleDateFormat ("yyyy.MM.dd hh:mm:ss");
	       String dateString = formatter.format(cal.getTime());


               String rcvDate = "";

               int day =  cal.get(Calendar.DATE);
               if ( day < 10 )  rcvDate = rcvDate + "0";
               rcvDate = rcvDate + Integer.toString(day) + ".";   
 
               int month = cal.get(Calendar.MONTH)+1;
               if (month < 10) rcvDate = rcvDate + "0";
               rcvDate = rcvDate + Integer.toString(month) + ".";
               rcvDate = rcvDate + Integer.toString(cal.get(Calendar.YEAR));

	       mails.append("<tr>\n");
               mails.append("<td bgcolor=\"" + bgColor + "\" bordercolor=\"" + 
                            "colspan=\"1\" align=\"center\"" +
			    getBorderColor() + "<input type=\"checkbox\"></td>");

               mails.append("<td bgcolor=\"" + bgColor + "\" bordercolor=\"" + 
			    getBorderColor() + "\" align=\"center\" nowrap colspan=\"1\">" +  
			    mh.getMyFlag() + "</td>" );

	       mails.append("<td bgcolor=\""+ bgColor + "\" bordercolor=\"" + 
			    getBorderColor() + "\" align=\"left\" nowrap colspan=\"4\">"  +
			    "<a href=\"../jsp/DisplayMessage.jsp?id=" + 
			    Integer.toString(mh.getMessageNumber())+ 
			    "\" target=\"msgview\"><pre>" + sub + "</pre></a></td>");

               mails.append( "<td bgcolor=\""+ bgColor + "\" bordercolor=\"" +
			     getBorderColor() + "\" align=\"left\" nowrap colspan=\"2\">"  +
			     "<a href=\"mailTo:" + from + "\">" + from + "</a></td>");

               mails.append("<td bgcolor=\"" + bgColor + "\" bordercolor=\"" +
			    getBorderColor() + "\" align=\"left\" nowrap colspan=\"2\">" +
			    dateString + "</td></tr>");

	       System.out.println(mails);
	                  
               if ( bgColor.equals(getRowColor1()) ) {
		   bgColor = getRowColor2();
               } else {
		   bgColor = getRowColor1();
               }
	    } System.out.println("Messages: " + mails.toString());
           }  else {
             mails = new StringBuffer(
		      "<tr><td bgcolor="+ bgColor + " bordercolor=\"" +
		      getBorderColor() + "\" align=\"left\" nowrap>"  +
		      "could not retrieve any Mail. Please try to <a href=\"index.html\">login</a> first.</td></tr>");
	  } 
    }
}
