package gpl.fredy.webmail;

import java.util.Properties;
import java.util.StringTokenizer;
import java.util.Vector;
import java.util.logging.*;
import javax.mail.*;
import javax.mail.internet.*;

import java.io.*;
import gpl.fredy.io.*;

public class MessageHandler {
    Logger logger = Logger.getLogger("gpl.fredy.webmail");
    Message message;
    
    /**
     * Get the value of message.
     * @return value of message.
     */
    public Message getMessage() {
        return message;
    }
    
    /**
     * Set the value of message.
     * @param v  Value to assign to message.
     */
    public void setMessage(Message  v) {
        this.message = v;
        setMessageHeader();
    }
    
    
    StringBuffer text;
    
    /**
     * Get the value of text.
     * @return value of text.
     */
    public StringBuffer getText() {
        return text;
    }
    
    /**
     * Set the value of text.
     * @param v  Value to assign to text.
     */
    public void setText(StringBuffer  v) {
        this.text = v;
    }
    private void addText(String v) {
        text.append(v);
    }
    
    
    public StringBuffer getReplyText() {
        
        StringBuffer buffer = new StringBuffer("\n\n");
        StringReader contentReader = new StringReader(getText().toString());
        BufferedReader br = new BufferedReader(contentReader);
        
        String contentLine;
        try {
            while ((contentLine = br.readLine()) != null) {
                buffer.append("> ");
                buffer.append(contentLine);
                buffer.append("\r\n");
            }
        } catch (IOException iox) { }
        return buffer;
    }
    
    private Vector attachementNames;
    private int    counter =-1;
    
    
    public Vector getAttachementNames() { return attachementNames; }
    
    String tmpDirectory;
    
    /**
     * Get the value of tmpDirectory.
     * @return value of tmpDirectory.
     */
    public String getTmpDirectory() {
        return tmpDirectory;
    }
    
    /**
     * Set the value of tmpDirectory.
     * @param v  Value to assign to tmpDirectory.
     */
    public void setTmpDirectory(String  v) {
        this.tmpDirectory = v;
        DirectoryHandler dh = new DirectoryHandler(v);
        dh.emptyDirectory();
    }
    
    
    String subject;
    
    private MessageHeader messageHeader;
    
    /**
     * Get the value of subject.
     * @return value of subject.
     */
    public String getSubject() {
        return subject;
    }
    
    /**
     * Set the value of subject.
     * @param v  Value to assign to subject.
     */
    public void setSubject(String  v) {
        this.subject = v;
    }
    
    
    public MessageHandler(Message message, String tmpDirectory) {
        
        setMessage(message);
        MimeMessage mm = (MimeMessage)message;
        Part        p  = mm;
        
        setTmpDirectory(tmpDirectory);
        text  = new StringBuffer((String)"");
        attachementNames = new Vector();
        try {
            setSubject(message.getSubject() );
        } catch (MessagingException mxe) {
            setSubject("no subject");
        }
        Object content=null;
        try {
            content = message.getContent();
        } catch ( Exception exc1){}
        if (content instanceof Multipart) {
            try {
                handleMultipart((Multipart)content);
            } catch (java.io.IOException iox){
                logger.log(Level.WARNING,"Exception while treating Multipart-Message: " + iox.getMessage());
            } catch (javax.mail.MessagingException mex) {
                logger.log(Level.WARNING,"Exception while treating Multipart-Message: " + mex.getMessage());
            }
        } else {
            try {
                handlePart(message);
            } catch (javax.mail.MessagingException mex2) {
                logger.log(Level.WARNING,"Exception while treating Multipart-Message: " + mex2.getMessage());
            } catch (java.io.IOException iox){
                logger.log(Level.WARNING,"Exception while treating Multipart-Message: " + iox.getMessage());
            }
        }
        
        //if ( p!=null )doIt(p);
    }
    private void doIt(Part p) {
        
        int partNumber = 0;
        counter = counter +1;
        try {
            System.out.println("Content-Type: " + p.getContentType());
            if ( p.isMimeType("text/plain") ) {
                System.out.println("einfache Meldung");
                addText((String)p.getContent());
                
            } else if  (p.isMimeType("multipart/*")) {
                
                System.out.println("Es ist eine multipart message");
                
                Multipart mp = (Multipart)p.getContent();
                
                Part bp  = mp.getBodyPart(partNumber);
                
                String disp = p.getDisposition();
                System.out.println("Disposition: " + disp);
                
                // first part is always the text
                if (partNumber == 0) disp = null;
                
                //if (disp == null || disp.equalsIgnoreCase(Part.ATTACHMENT)) {
                if ((disp != null) && ((disp.equals(Part.ATTACHMENT) || (disp.equals(Part.INLINE)) ))) {
                    System.out.println("Handling multipart");
                    String filename =  bp.getFileName();
                    if (filename != null ) {
                        attachementNames.addElement((String)filename);
                        
                        //addText("\n\n*************** Message " + Integer.toString(counter) + "\n\n");
                        addText("\n\n***************  " + filename + "\n\n");
                        
                        // let's extract this attachement
                        InputStream is = bp.getInputStream();
                        try {
                            FileOutputStream out = new FileOutputStream(getTmpDirectory() +  File.separator + filename);
                            int c;
                            while ((c = is.read()) != -1) {
                                out.write(c);
                            }
                            is.close();
                            out.flush();
                            out.close();
                        } catch (IOException ioex) {
                            logger.log(Level.WARNING,"Can not write attachement: " + ioex.getMessage().toString());
                        }
                    }
                } else {
                    try {
                        addText((String)p.getContent());
                    } catch (Exception inlinexception) {}
                }
                
                int count = mp.getCount();
                //System.out.println("Message hat " + count + " Parts");
                for (partNumber=0; partNumber < count; partNumber++) {
                    doIt(mp.getBodyPart(partNumber));
                }
                partNumber = 0;
                
            } else if (p.isMimeType("message/rfc822")) {
                doIt((Part)p.getContent());
                addText( "\n***************NESTED MESSAGE " + Integer.toString(counter) + "\n\n");
                
            } else {
                Object o = p.getContent();
                if (o instanceof String) {
                    addText((String)p.getContent());
                    
                    
                }else if (o instanceof InputStream) {
                    
                    //System.out.println("es ist ein outputstream");
                    
                    //Multipart mp = (Multipart)p.getContent();
                    
                    //Part bp  = mp.getBodyPart(partNumber);
                    //String filename =  bp.getFileName();
                    String filename =  p.getFileName();
                    if (filename == null ) filename="NoName";
                    
                    InputStreamReader is = new InputStreamReader((InputStream)o);
                    //InputStreamReader is = new InputStreamReader(bp.getInputStream());
                    attachementNames.addElement((String)filename);
                    
                    try {
                        File newFile = new File(getTmpDirectory() +  File.separator + filename);
                        
                        DataOutputStream out = new DataOutputStream(
                        new BufferedOutputStream(
                        new FileOutputStream(newFile)));
                        
                        int c;
                        while ((c = is.read()) != -1) {
                            out.writeChar(c);
                        }
                        is.close();
                        out.flush();
                        out.close();
                    } catch (IOException ioex) {
                        logger.log(Level.WARNING,"Can not write attachement: " + ioex.getMessage().toString());
                    }
                } else {
                    addText( o.toString() );
                    
                }
            }
            
            
        } catch (Exception be) {
            //System.out.println("MessageHandler Exception: " + be.getMessage().toString());
            be.printStackTrace();
        }
    }
    
    public String getSender() {
        String from = "";
        try {
            for (int i=0; i < getMessage().getFrom().length; i++ ) {
                InternetAddress frm = new InternetAddress(getMessage().getFrom()[i].toString());
                if ( i > 0) from = from + ";";
                from = from + frm.getAddress();
            }
        } catch ( javax.mail.MessagingException mex){
            from = mex.getMessage();
        }
        return from;
    }
    
    public String getRecepients() {
        String to ="";
        try {
            for (int i=0; i < getMessage().getRecipients(Message.RecipientType.TO).length; i++ ) {
                InternetAddress rcv = new InternetAddress(getMessage().getRecipients(Message.RecipientType.TO)[i].toString());
                if ( i > 0) to = to + ";";
                to = to + rcv.getAddress();
            }
        } catch ( javax.mail.MessagingException mex){
            to = mex.getMessage();
        }
        return to;
    }
    
    
    public String getReplyTo() {
        String rply="";
        try {
            for (int i=0; i < getMessage().getReplyTo().length;i++ ) {
                InternetAddress rpl = new InternetAddress(getMessage().getReplyTo()[i].toString());
                if ( i > 0 ) rply = rply + ";";
                rply = rply +  rpl.getAddress();
            }
        } catch ( javax.mail.MessagingException mex){
            rply = mex.getMessage();
        }
        return rply;
    }
    
    /**
     * Getter for property messageHeader.
     * @return Value of property messageHeader.
     */
    public gpl.fredy.webmail.MessageHeader getMessageHeader() {
        return messageHeader;
    }
    
    /**
     * Setter for property messageHeader.
     * @param messageHeader New value of property messageHeader.
     */
    public void setMessageHeader() {
        messageHeader = new MessageHeader(getMessage());
    }
    public  void handleMultipart(Multipart multipart)
    throws MessagingException, IOException {
        //System.out.println("handling multipart");
        for (int i=0, n=multipart.getCount(); i<n; i++) {
            handlePart(multipart.getBodyPart(i));
        }
    }
    public  void handlePart(Part part)
    throws MessagingException, IOException {
        //System.out.println("Handling part");
        String disposition = part.getDisposition();
        String contentType = part.getContentType();
        if (disposition == null) { // When just body
            
            // Check if plain
            if ((contentType.length() >= 10) &&
            (contentType.toLowerCase().substring(
            0, 10).equals("text/plain"))) {
                addText((String)part.getContent());
            } else { // Don't think this will happen
                //addText((String)part.getContent());
                // part.writeTo(System.out);
            }
        } else if (disposition.equalsIgnoreCase(Part.ATTACHMENT)) {
            saveFile(part.getFileName(), part.getInputStream());
        } else if (disposition.equalsIgnoreCase(Part.INLINE)) {
            saveFile(part.getFileName(), part.getInputStream());
        } else {  // Should never happen
            System.out.println("Other: " + disposition);
        }
    }
    public void saveFile(String filename,
    InputStream input) throws IOException {
        if (filename == null) {
            filename = "NoName.out";
        }
        attachementNames.addElement((String) filename);
        
        //System.out.println("Writing file: " + getTmpDirectory() + File.separator + filename);
        
        // Do no overwrite existing file -> no, just do it
        File file = new File(getTmpDirectory() + File.separator + filename);
        
        for (int i=0; file.exists(); i++) {
            file = new File(filename+i);
        }
        FileOutputStream fos = new FileOutputStream(file);
        BufferedOutputStream bos = new BufferedOutputStream(fos);
        
        BufferedInputStream bis = new BufferedInputStream(input);
        int aByte;
        while ((aByte = bis.read()) != -1) {
            bos.write(aByte);
        }
        bos.flush();
        bos.close();
        bis.close();
    }
}
